Subject: Re: Route cache performance under stress

From: "David S. Miller" <[email-masked]>
Date: Thu, 12 Jun 2003 14:35:40 -0700 (PDT)

From: Robert Olsson <[email-masked]>
   Date: Thu, 12 Jun 2003 15:56:47 +0200

   David S. Miller writes:
   
    > That is a lot more work, but it would validate the various ideas and
    > claims being made.  For example, it would say for sure whether
    > eliminating the routing cache is a win or not for DoS traffic.
   
    Well it's true. But do we need too? From the profile we actually see the 
    'dst' management cost. Not much I would say and still we will need some 
    adminstration i.e refcounting even it we should remove the route hash.

But Robert, do you know "why" the dst management doesn't show up in
your profiles when you rip-out the rtcache?

It's because to total number of DST entries is so small that they all
fit in the cpu cache.  When the rtcache is enabled and we thus have up
to "max_size" DST entries in flight at all times, the dst management
routines show up very clearly because they have a high probability of
missing the cpu cache.

In particular, have a good look at Simon's profiles.  dst_alloc() is
quite near the top there.